/* 페이징 관련 변수 */
let appEventTotalCount   = 0;
let appEventTotalPages   = 0;

/*aggird*/
let appEventAgGridData = [];

let appEventSelectId = "";

/****************************************************************************
 * 검색 날짜 설정
 //(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
 ****************************************************************************/
function fn_appEventSetDate(param){
    if("A"==param){
        // 오늘
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchStartDate = year+'-'+month+'-'+day;
        appEventSearchEndDate   = year+'-'+month+'-'+day;
    }
    else if("B"==param){
        // 3일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 3);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("C"==param){
        // 이번주
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 7);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("D"==param){
        // 최근30일
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        //최근30일
        toDate.setDate(toDate.getDate() - 30);
        startYear  = toDate.getFullYear();
        startMonth = toDate.getMonth() + 1;
        startDay   = toDate.getDate();

        if(startMonth < 10) startMonth = "0" + startMonth;
        if(startDay < 10) startDay = "0" + startDay;

        appEventSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
        appEventSearchEndDate   = year+'-'+month+'-'+day;

    }
    else if("E"==param){
        // 최근90일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 90);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("F"==param){
        //F:이번달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appEventSearchStartDate = year+'-'+month+'-01';
    }
    else if("G"==param){
        // G:올해
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appEventSearchStartDate = year+'-01-01';
    }
    else if("H"==param){
        // H:지난주, I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appEventSearchStartDate = year+'-01-01';
    }
    else if("I"==param){
        // I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appEventSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appEventSearchStartDate = year+'-01-01';
    }

    $("#appEventSearchStartDate").val(appEventSearchStartDate).trigger("change");
    $("#appEventSearchEndDate").val(appEventSearchEndDate).trigger("change");
}


/****************************************************************************
 * 이벤트 정보 리스트 조회
 ****************************************************************************/
function fn_selectListAppEventJson(){
    let formData = new FormData();
    formData.append("menuClass", menuClass);
    formData.append("appEventSearchKeywordParam", appEventSearchKeywordParam);
    formData.append("appEventSort", appEventSort);
    formData.append("appEventDir", appEventDir);
    formData.append("appEventStart", appEventStart);
    formData.append("appEventLimit", appEventLimit);
    formData.append("appEventSearchStartDate", appEventSearchStartDate);
    formData.append("appEventSearchEndDate", appEventSearchEndDate);
    formData.append("appEventSearchDateType", appEventSearchDateType);

    $.ajax({
        url: encodeURI('/webappevent/selectListAppEvent.do'),
        data: formData,
        dataType: "json",
        processData: false,
        contentType: false,
        type: 'POST',
        async: true,
        success: function(data){
            if('0'==data.msgCode){
                // 페이징 처리
                appEventTotalCount  = data.totalCount;
                //$("#txt_noticeTotalCount").text(noticeTotalCount);

                appEventTotalPages = Math.ceil(appEventTotalCount/appEventLimit);

                // 리스트 조회
                appEventAgGridData = data.rows;
                appEventGridOptions.api.setRowData(appEventAgGridData);

                if(0<data.rows.length){
                    //페이징 처리
                    window.pagObj = $('#appEventPagination').twbsPagination({
                        startPage    : ((appEventStart/appEventLimit)+1),
                        totalPages   : (appEventTotalPages==0)?1:appEventTotalPages,
                        visiblePages : 10,
                        initiateStartPageClick: false,
                        prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
                        next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
                        first        : '',
                        last         : '',
                        onPageClick: function (event, page) {
                            fn_appEventPagination(page);
                        }
                    }).on('page', function (event, page) {
                        //console.info(page + ' (from event listening)');
                    });
                }
                else{

                }
            }
            else{
                modalEvent.danger("조회 오류", data.msgDesc);
            }
        },
        error : function(xhr, status, error) {
            modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
        },
        beforeSend:function(){
            // 로딩열기
            appEventGridOptions.api.showLoadingOverlay();
        },
        complete:function(){

        }
    });
}

/****************************************************************************
 * 검색하기
 ****************************************************************************/
function fn_appEventSearch(param){
    if("A"!=param && "Y"!=selectUseYn){
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }

    fn_appEventPaginReset();

    appEventSearchKeywordParam = $("#appEventSearchKeyword").val();

    appEventSearchDateType  = $("#appEventSearchDateType").val();
    appEventSearchStartDate = $("#appEventSearchStartDate").val();
    appEventSearchEndDate   = $("#appEventSearchEndDate").val();

    fn_selectListAppEventJson();
}


/****************************************************************************
 * 초기화하기
 ****************************************************************************/
function fn_appEventReset(){
    fn_appEventSetDate('D');
    $("#appEventSearchDateType option:eq(0)").prop("selected", true);

    $("#appEventSearchKeyword").val("");

    fn_appEventSearch();
}

/****************************************************************************
 * 페이징 처리
 ****************************************************************************/
function fn_appEventPagination(param){
    appEventStart = (parseInt(param)-1)*appEventLimit;

    fn_selectListAppEventJson();
}

/****************************************************************************
 * 페이징 리셋
 ****************************************************************************/
function fn_appEventPaginReset(){
    appEventSearchKeywordParam = '';

    appEventStart        = 0;
    appEventLimit        = 100;
    appEventTotalCount   = 0;
    appEventTotalPages   = 0;

    //페이징 초기화
    if($("#appEventPagination").data("twbs-pagination")){
        $("#appEventPagination").twbsPagination("destroy");
    }
}

/****************************************************************************
 * 이벤트 삭제
 ****************************************************************************/
function fn_deleteAppEvent(){
    if("Y"!=deleteUseYn){
        modalEvent.warning("", "삭제 권한이 없습니다.");
        return false;
    }

    if(!appEventSelectId){
        modalEvent.warning("", "삭제할 대상을 선택하세요.");
        return false;
    }

    modalEvent.info("삭제", "선택한 이벤트 정보를 삭제하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("selectId", appEventSelectId);

        $.ajax({
            url: encodeURI('/webappevent/deleteAppEvent.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("삭제 성공", data.msgDesc, function(){
                        fn_appEventOk();
                    });
                }
                else{
                    modalEvent.danger("삭제 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 검색 엔터 이벤트
 ****************************************************************************/
function fn_appEventEnter(e){
    if(e.which){
        // 파이어폭스
        if(13 == e.which) {
            //로그인 액션 스크립트
            fn_appEventSearch();
        }
    }
    else{
        // 윈도우, 사파리, 크롬
        if(13 == event.keyCode) {
            //로그인 액션 스크립트
            fn_appEventSearch();
        }
    }
}

/****************************************************************************
 * 정렬 이벤트
 ****************************************************************************/
function fn_alignEvent(param, param2){
    let align = "";

    if("A"==param){
        align = "오늘";

        fn_appEventSetDate('A');
    }
    else if("B"==param){
        align = "최근30일";

        fn_appEventSetDate('D');
    }
    else if("C"==param){
        align = "최근90일";

        fn_appEventSetDate('E');
    }
    else if("D"==param){
        align = "이번주";

        fn_appEventSetDate('C');
    }
    else if("E"==param){
        align = "이번달";

        fn_appEventSetDate('F');
    }
    else if("F"==param){
        align = "올해";

        fn_appEventSetDate('G');
    }
    else if("G"==param){
        align = "지난주";

        fn_appEventSetDate('H');
    }
    else if("H"==param){
        align = "지난달";

        fn_appEventSetDate('I');
    }
    else{
        align = "";
    }
    $("#appEventSearchDateType").val(param);
    $("#appEventSearchDateType").siblings("button").text(align);
}

/****************************************************************************
 * 완료
 ****************************************************************************/
function fn_appEventOk(){
    fn_appEventReset();
}

/****************************************************************************
 * 등록 화면으로 이동.
 ****************************************************************************/
function fn_insertAppEventIntro(){
    if("Y"==insertUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/webappevent/insertEventIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

}

/****************************************************************************
 * 수정 화면으로 이동.
 ****************************************************************************/
function fn_updateAppEventIntro(muAppEventId){
    if("Y"==updateUseYn){
        let pagingParam = "?menuClass="+menuClass;
        pagingParam    += "&muAppEventId="+muAppEventId;
        fn_leftFormAction("/webappevent/updateEventIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "수정 권한이 없습니다.");
        return false;
    }
}


let appEventColumnDefs = [
    {field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},
    /* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
    {field: "rowNum", headerName:"번호", minWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
    {field: "title", headerName:"제목", minWidth:250, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
    {field: "content", headerName:"내용",minWidth:500},
    {field: "eventDate", headerName:"기간",minWidth:250, maxWidth:250},
    {field: "exposedYn", headerName:"메인 홈 노출 여부",minWidth:150, maxWidth:150},
    {field: "writeName", headerName:"작성자",minWidth:150, maxWidth:200},
    {field: "writeDate", headerName:"등록일",minWidth:150, maxWidth:150}
];

// let the grid know which columns and what data to use
let appEventGridOptions = {
    suppressRowTransform: true,
    columnDefs: appEventColumnDefs,
    defaultColDef: {		// 리스트 기본 설정
        flex: 1,
        sortable: true,		//정렬 여부
        resizable: true,	//리사이즈
        editable: true,	// 그리드에서 데이터 수정
        cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
        //suppressSizeToFit:true,		//자동 맞춤
        //enableRowGroup: true,		// 그룹 묶음
        enablePivot: true,
        enableValue : true
    },
    //suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
    headerHeight : 41, // header 높이
    rowHeight : 41, // row 높이
    rowData : appEventAgGridData,
    suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
    localeText : {
        noRowsToShow : '조회 결과가 없습니다.'
    }, //데이터 없을 시 나오는 문구
    rowSelection : 'multiple', // row 다중 선택
    debug : false,
    onCellClicked: function(event){ //셀 클릭 이벤트
        /* alert(event.column.colId); */
        if('title'==event.column.colId){
            fn_updateAppEventIntro(event.data.muAppEventId);
        }
    },
    onSelectionChanged: function(event){ //체크박스 선택
        let selectRows = [];
        selectRows = event.api.getSelectedRows();

        appEventSelectId = '';
        for(let i=0; i<selectRows.length; i++){
            appEventSelectId += selectRows[i].muAppEventId + ",";
        }
        appEventSelectId = appEventSelectId.substring(0, appEventSelectId.lastIndexOf(','));
    },
    onSortChanged: function(event){
        //정렬
        appEventSort = ''; //기존 정렬 초기화
        let columnArr = event.columnApi.getColumnState();
        if(0<columnArr.length){
            //sort index 순으로 재정렬
            columnArr.sort(function(a,b){
                return a.sortIndex - b.sortIndex;
            });

            let nullCnt = 0;
            for(let i=0; i<columnArr.length; i++){
                let gridSortModel = columnArr[i].colId;
                let gridSort = columnArr[i].sort;

                if(gridSort != null){
                    appEventStart = 0;
                    appEventSort += gridSortModel+' '+ gridSort + ',';
                }
                else{
                    nullCnt++;
                    if(nullCnt == columnArr.length){
                        appEventSort = '';
                        appEventDir = '';
                        appEventStart = 0;
                    }
                }
            }
        }
        appEventSort = appEventSort.substring(0,appEventSort.lastIndexOf( ",")); //맨끝 콤마 지우기

        fn_appEventSearch();
    }
};

// lookup the container we want the Grid to use
let appEventGridDiv = document.querySelector('#appEventGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(appEventGridDiv, appEventGridOptions);





/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#divAppEventSearchStartDate", "#divAppEventSearchEndDate");

    if(!appEventSearchStartDate&&!appEventSearchEndDate){
        // 검색 오늘날짜 셋팅
        fn_appEventSetDate('D');
    }else{
        $("#appEventSearchStartDate").val(appEventSearchStartDate).trigger("change");
        $("#appEventSearchEndDate").val(appEventSearchEndDate).trigger("change");
    }

    // 초기 페이징 처리
    $("#appEventSearchKeyword").val(appEventSearchKeywordParam);

    fn_appEventSearch("A");
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $(document).on('keypress', '#appEventSearchKeyword', function(e) {
        fn_appEventEnter(e);
    });

    // 검색 조회 버튼
    $("#btnSearchAppEvent").click(function () {
        fn_appEventSearch();
    });

    // 이벤트 등록 팝업 버튼
    $("#btnInsertAppEvent").click(function () {
        fn_insertAppEventIntro();
    });

    // 이벤트 삭제 버튼
    $("#btnDeleteAppEvent").click(function () {
        fn_deleteAppEvent();
    });

    // 기간 선택 콤보 이벤트
    const target = $("#appEventSearchDateType").siblings("ul.select_option_list");
    target.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);

        fn_alignEvent(selectId);
    });
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});